//========================================================================================
// Copyright (c) 2002, Sunplus Technology Co., Ltd.
// CONFIDENTIAL INFORMATION - This information in its original or translated
// form (compiled, assembled, object module or otherwise) is CONFIDENTIAL
// INFORMATION and the property of Sunplus Technology Co., Ltd.
// Progarm:	GPL951 I2C Sample Program		(Modify from SPL16256 I2C Sample Program)
// Arranged by: Frank Kung
//========================================================================================
//.PUBLIC 	_BREAK, _FIQ, _IRQ0, _IRQ1, _IRQ2, _IRQ3, _IRQ4, _IRQ5, _IRQ6, _IRQ7;
.PUBLIC		_main
.INCLUDE	GPL951_Body.inc

.define	FPGA_Test	1
.define	C_SystemClock	96000000
.define IIC_clock	1000000
.define IIC_CLK_Reg	C_SystemClock/(2*IIC_clock)-1

//////////////////////////////
workram:	.section	.RAM 
//////////////////////////////
	.VAR	R_Error
	.var	R_Temp
	.var	R_TestLoop
	.var	R_Address
	.var	R_CompleteFlag
	.var	R_DataCount
	.var	R_NACK
	.var	R_ReadCount
R_DataBuffer: .dw 0x1000 dup(?)
	
//////////////////////////////
.code
//////////////////////////////
//

_main:
// IOF as I2C Function Enable
	r1=[P_IOA_Data]
	test r1,0x01		//IOA0=1, IIC config on IOC, 	
	jnz	skip?			//IOA0=0, IIC config on IOF
	r1 = 0x41
	[P_IOF_Mux] = r1
	jmp conti?
skip?:	
// IOC as I2C Function Enable
	r1 = 0x1001
	[P_IOC_Mux] = r1	
conti?:	
	
	r1 = 0xFF
	[P_IOB_Attrib] = r1
	[P_IOB_Dir] = r1
	
	r1 = 0x0
	[P_IOB_Buffer] = r1

// IOD as I2C Function Enable
//	r1 = 0x11
//	[P_IOD_Mux] = r1
	
	r1=[P_IOA_Data]
	test r1,0x02
	jnz	slavemode?
mastermode?:
	call	F_IICTest_Master
	nop
	nop
	jmp	$
slavemode?:	
	call	F_IICTest_Slave
	nop
	nop
	jmp	$

//##########################
//	test device 24lc32 EEPROM	//4Kbyte size
//##########################
.define	SlaveAddr_W	0xa0
.define	SlaveAddr_R	0xa1

F_IICTest_Master:
	r1=R_DataBuffer
	r2=1
loop?:				
	ds:[r1++]=r2
	r2+=1
	cmp	r2,0x1001		//write 4K word
	jnz	loop?
//----------------------
	r1=0x0090
	[P_I2C_Ctrl]=r1	
	r1=0x00d0
	[P_I2C_Status]=r1
	r1=0x010
	[P_I2C_Debounce]=r1
	r1=0x01
	[P_I2C_MISC]=r1
	r1=IIC_CLK_Reg&0x00FF
	[P_I2C_Clk]=r1
	r1=IIC_CLK_Reg&0x0F00
	r1=r1 lsr 4
	r1=r1 lsr 4
	r1|=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r1

//-----------------------
//	irq	on
	
	r1=0
	[R_Address]=r1
	r1=R_DataBuffer
	
	r3=0x3//0x1000			//4K byte length
//////////////////////////	
Master_WriteLoop:
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2
	r2=SlaveAddr_W
	[P_I2C_Data]=r2
	r2=0
	[R_CompleteFlag]=r2
	r2=0x0f0
	[P_I2C_Status]=r2			//send device address
	call	F_CheckComplete
	r4=[R_Address]
	r2=r4 lsr 4
	r2=r2 lsr 4
	[P_I2C_Data]=r2
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2				//send data address 1
	call	F_CheckComplete
	[P_I2C_Data]=r4
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2				//send data address 2
	call	F_CheckComplete
	r4=[R_Address]
	r4+=1
	[R_Address]=r4
	r2=ds:[r1++]
	[P_I2C_Data]=r2
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2				//send data
	call	F_CheckComplete
	r2=0x0d0				//stop
	[P_I2C_Status]=r2	
	call	ProgrammingWait		//wait EEPROM programming
	r3-=1
	jnz	Master_WriteLoop
	nop
	nop	
//////////////////////////////////	
	r1=0x00
	[R_Address]=r1
	r1=R_DataBuffer
	r3=0x3//0x1000
Master_ReadLoop:
/// Debug for clk < 11KHz ///	
busy1?:
	r2=[P_I2C_Status]
	test	r2,0x020
	jnz	busy1?	
////////////////////////////	
	r2=[P_I2C_Ctrl]		//enable ack
	r2|=0x080
	[P_I2C_Ctrl]=r2
	
	r2=0x0d0			//change to master transmit mode
	[P_I2C_Status]=r2	
	r2=SlaveAddr_W
	[P_I2C_Data]=r2
	r2=0
	[R_CompleteFlag]=r2
	r2=0x0f0
	[P_I2C_Status]=r2		//send device address
	call	F_CheckComplete
	r4=[R_Address]
	r2=r4 lsr 4
	r2=r2 lsr 4
	[P_I2C_Data]=r2
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2			//send data address 1
	call	F_CheckComplete
	[P_I2C_Data]=r4
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2			//send data address 2
	call	F_CheckComplete
	r4=[R_Address]
	r4+=1
	[R_Address]=r4
	
////////////////////////////	
	r2=SlaveAddr_R
	[P_I2C_Data]=r2
	r2=0
	[R_CompleteFlag]=r2
	r2=0x0b0
	[P_I2C_Status]=r2			// Master RX and start cmd
	call	F_CheckComplete

	r2=[P_I2C_Ctrl]
	r2&=~0x080
	[P_I2C_Ctrl]=r2
	call	F_CheckComplete_R
	nop
	r2=ds:[r1++]
	r2&=0x0ff
	cmp	r2,[P_I2C_Data]
	jne	DataError

	r2=0xd0
	[P_I2C_Status]=r2
	nop
	r3-=1
	jz	testend?
	goto	Master_ReadLoop
testend?:	
	nop
	jmp	$					//test ok
		
DataError:
	nop
	jmp	$	


.comment @
//##########################
//	test device 24lc64 EEPROM
//##########################
.define	SlaveAddr_W	0xa0
.define	SlaveAddr_R	0xa1

F_IICTest_Master:
	r1=0x0
	r2=1
loop?:				
	ds:[r1++]=r2
	r2+=1
	cmp	r1,0x1000		//write 8K
	jnz	loop?

//----------------------
	r1=0x0091
	[P_I2C_Ctrl]=r1	
	r1=0x00d0
	[P_I2C_Status]=r1
	r1=0x010
	[P_I2C_Debounce]=r1
	r1=0x01
	[P_I2C_MISC]=r1
//-----------------------
//	irq	on
	
	r1=0x00
	[R_Address]=r1
	
	r3=0x1000
//////////////////////////	
Master_WriteLoop:
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2
	r2=SlaveAddr_W
	[P_I2C_Data]=r2
	r2=0
	[R_CompleteFlag]=r2
	r2=0x0f0
	[P_I2C_Status]=r2			//send device address
	call	F_CheckComplete
	r4=[R_Address]
	r2=r4 lsr 4
	r2=r2 lsr 4
	[P_I2C_Data]=r2
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2				//send data address 1
	call	F_CheckComplete
	[P_I2C_Data]=r4
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2				//send data address 2
	call	F_CheckComplete
	r4=[R_Address]
	r4+=1
	[R_Address]=r4
	r2=ds:[r1++]
	[P_I2C_Data]=r2
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2				//send data
	call	F_CheckComplete
	r2=0x0d0				//stop
	[P_I2C_Status]=r2	
	call	ProgrammingWait		//wait EEPROM programming
	r3-=1
	jnz	Master_WriteLoop
	nop
	nop	
//////////////////////////////////	
	r1=0x00
	[R_Address]=r1
	r3=0x1000
Master_ReadLoop:
/// Debug for clk < 11KHz ///	
busy1?:
	r2=[P_I2C_Status]
	test	r2,0x020
	jnz	busy1?	
////////////////////////////	
	r2=[P_I2C_Ctrl]		//enable ack
	r2|=0x080
	[P_I2C_Ctrl]=r2
	
	r2=0x0d0			//change to master transmit mode
	[P_I2C_Status]=r2	
	r2=SlaveAddr_R
	[P_I2C_Data]=r2
	r2=0
	[R_CompleteFlag]=r2
	r2=0x0f0
	[P_I2C_Status]=r2		//send device address
	call	F_CheckComplete
	r4=[R_Address]
	r2=r4 lsr 4
	r2=r2 lsr 4
	[P_I2C_Data]=r2
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2			//send data address 1
	call	F_CheckComplete
	[P_I2C_Data]=r4
	r2=[P_I2C_Ctrl]
	[P_I2C_Ctrl]=r2			//send data address 2
	call	F_CheckComplete
	r4=[R_Address]
	r4+=1
	[R_Address]=r4
	
////////////////////////////	
	r2=SlaveAddr_R
	[P_I2C_Data]=r2
	r2=0
	[R_CompleteFlag]=r2
	r2=0x0b0
	[P_I2C_Status]=r2			// Master RX and start cmd
	call	F_CheckComplete

	r2=[P_I2C_Ctrl]
	r2&=~0x080
	[P_I2C_Ctrl]=r2
	call	F_CheckComplete_R
	nop
	r2=ds:[r1++]
	r2&=0x0ff
	cmp	r2,[P_I2C_Data]
	jne	DataError

	r2=0xd0
	[P_I2C_Status]=r2
	nop
	r3-=1
	jz	testend?
	goto	Master_ReadLoop
testend?:	
	nop
	jmp	$					//test ok
		
DataError:
	nop
	jmp	$	
@

//##########################
//	test with GPL833F12A
//##########################
.define	SlaveAddr	0x0a0	//0x05a
F_IICTest_Slave:
//	ds=3
	r1=0
	r2=0
loop?:	
	ds:[r1++]=r2
//	cmp	r1,0
	cmp	r1,0x1fff
	jne	loop?		
//	r2=0xffff
	r1 = 0
	r2 = 0x1fff
loop1?:	
	ds:[r1++]=r2
	r2-=1
//	cmp	r1,0
	cmp	r1, 0x1fff
	jne	loop1?

	irq on
//----------------------------	
	r1=0xB0				//0xf0
	[P_I2C_Ctrl]=r1
	r1=0x010
	[P_I2C_Debounce]=r1
	r1=0x01
	[P_I2C_MISC]=r1
	r1=SlaveAddr
	[P_I2C_Address]=r1
///////////////////////////
//	ds=0x03
	r1=0
	r3=0
	[R_DataCount] = r1
	[R_Address]	 = r1
	[R_NACK] = r1
	

	r2=0x010				//slave receive mode
	[P_I2C_Status]=r2
//	r2=0
//	[R_CompleteFlag]=r2
	r4 = 0x100

////////////////////////////////////
// Function : Byte Write
// Master : GPL833F12A
// Slave : GPL951
// Address : $00, Data : 0xFF ; 
// Address : $01, Data : 0xFE ;
// ....
// Address : $FF, Data : 0x00
// Saved data into $100 ~ $3FF
///////////////////////////////////
F_Slave_ByteWrite:
L_GetDeviceID?:
	r2=[P_I2C_Status]
	test	r2,0x004
	jz		L_GetDeviceID?
	call	L_SaveData?
		
L_GetAddress?:
	r2=0
	[R_CompleteFlag]=r2
	call	L_checkdone?	
	call	L_SaveData?	
	
L_GetData?:
	r2=0
	[R_CompleteFlag]=r2
	call	L_checkdone?	
	call	L_SaveData?	
	
	call	L_Checkbusy?		
	r1 = [R_DataCount]
	r1+=1
	[R_DataCount] = r1
	cmp r1, 0x0100
 	jnz L_GetDeviceID?
 	
//////////////////////////////////////////////////////////////////////////////////////
// Function : RandomRead
// Master : GPL833F12A
// Slave : GPL951
// Address : $00, Data : 0xFF ; 
// Address : $01, Data : 0xFE ;
// ....
// Address : $FF, Data : 0x00
// Address : 0x500 (Device ID) ; 0x501 (Address) ; 0x502 (Send Data (get from 0x102)
//			 0x503 (Device ID) ; 0x504 (Address) ; 0x505 (Send Data (get from 0x105)
//           ...
//			 0x7fd (Device ID) ; 0x7fe (Address) ; 0x7ff (Send Data (get from 0x3ff)
//////////////////////////////////////////////////////////////////////////////////////
	r1=0
	[R_DataCount] = r1
	[R_NACK] = r1	
	r1 = 0x100
	[R_Address]	 = r1
	r4 = 0x500
F_Slave_RandomRead?:
L_GetDeviceID_Write?:
	r2=0x010				//slave receive mode
	[P_I2C_Status]=r2	

	r2=[P_I2C_Status]
	test	r2,0x004
	jz		L_GetDeviceID_Write?
	call	L_SaveData?	
	
L_GetAddress_Read?:
	r2=0
	[R_CompleteFlag]=r2
	call	L_checkdone?	
	call	L_SaveData?	
	
	r2=0x70					//slave transmit mode
	[P_I2C_Status]=r2 	
	
L_GetDeviceID_Read?:
	r2=[P_I2C_Status]
	test	r2,0x004
	jz		L_GetDeviceID_Read?
	
L_SendData?:
	r1 = 0x01
	[R_NACK] = r1
	
	r2=0
	[R_CompleteFlag]=r2	
	call	L_checkdone?
	call	L_SaveData?
		
L_SendNack?:
	r1 = [P_I2C_Ctrl]
	r1 &= ~0x80
	[P_I2C_Ctrl] = r1
	
	r2=0
	[R_CompleteFlag]=r2	
	call	L_checkdone?	
	
	call	L_Checkbusy?
	r1 = [P_I2C_Ctrl]
	r1 |= 0x80
	[P_I2C_Ctrl] = r1		
			
	r1 = [R_DataCount]
	r1+=1
	[R_DataCount] = r1
	cmp r1, 0x0100
 	jnz F_Slave_RandomRead?
 	
 L_SlavePass?:
 	jmp	L_SlavePass?
 	
	
 	
L_checkdone?:
	r2 = [R_CompleteFlag]
	test	r2,0x001
	jz		L_checkdone?
	retf
	
L_SaveData?:
	r2 = [P_I2C_Data]
	ds:[r4++]=r2
	retf
	
L_Checkbusy?:
	r2=[P_I2C_Status]
	test	r2,0x020
	jnz		L_Checkbusy?
	retf			



//##############################
F_CheckComplete:
	push	r2 to [sp]
wait?:
	r2=[P_I2C_Ctrl]
	test	r2,0x010
	jz	wait?
		
	r2=0
	[R_CompleteFlag]=r2
	r2=[P_I2C_Status]
	test	r2,0x08
	jnz	error
	test	r2,0x01
	jnz	error
	call	F_Delay
	pop r2 from [sp]
	retf

F_CheckComplete_R:
	push	r2 to [sp]
wait?:
	r2=[P_I2C_Ctrl]
	test	r2,0x010
	jz	wait?
	
	r2=0
	[R_CompleteFlag]=r2
	r2=[P_I2C_Status]
	test	r2,0x08
	jnz	error
	call	F_Delay
	pop r2 from [sp]
	retf
	
error:
	nop
	jmp	$	
//******************************
F_Delay:
	push r1 to [sp]
	r1=1024
d1?:	
	r1-=1
	jnz	d1?
	pop	r1 from [sp]
	retf	

//#############################
ProgrammingWait:
	push	r1,r2 to [sp]
	r1=0x100
d1?:	
	r2=0x200
d2?:
	r2-=1
	jnz	d2?
	r1-=1
	jnz	d1?
	pop	r1,r2 from [sp]
	retf	
//******************************
//---------------------------------------------------------------
.text
//---------------------------------------------------------------
_BREAK:
		reti
_FIQ:
		reti
_IRQ0:
		reti
_IRQ1:
        reti
_IRQ2:
        reti
_IRQ3:
        reti

_IRQ4:
	push	r1,r4 to [sp]
	
	pop	r1,r4 from [sp]
    reti

_IRQ5:
		push r1 to [sp]
		
		// Frank add for debug //
		r1 = [P_IOB_Buffer]
		r1^= 0x01
		[P_IOB_Buffer] = r1
		////////////////////////
		
		r1=[P_INT_Status2]
		test	r1,C_INT_I2C_IF
		jz	endirq5?
		
		// If R_NACK = 0x1, it means that send data (load data into P_I2C_Data
		r1 = [R_NACK]
		test r1, 0x01
		jz	endirq5?
		
		// Get data from R_Address (GPL833F12A byte write, GPL951 Receive data (0x102, 0x105, ...)
		r1 = [R_Address]
		r1+=2
		[R_Address] = r1	
		r2 = ds:[r1]
		[P_I2C_Data] = r2
		
		//Clear NACK Flag	
		r1 = 0x00
		[R_NACK] = r1
		r1 = [R_Address]
		r1+=1
		[R_Address] = r1	
				
endirq5?:
		r1=[P_I2C_Ctrl]
		[P_I2C_Ctrl]=r1
		r1=0x01
		[R_CompleteFlag]=r1
				
		pop	r1 from [sp]
        reti
        
_IRQ6:
		reti
_IRQ7:
        reti


.END
